#include <linux/init.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/ioctl.h>
#include <linux/kernel.h>
#include <asm/system.h>
#include <asm/segment.h>
#include <asm/io.h>
#include <linux/ioport.h>
#include <linux/pci.h>

#include "dwatchdog.h"

#include <asm/uaccess.h>

/* I defined some macro for device_open function */
#define TYPE(dev) (MINOR(dev) >> 4) 
#define NUM(dev) (MINOR(dev) & 0x0f)

#ifndef DECISION_VENDOR_ID
#define DECISION_VENDER_ID 0x6666
#endif

#ifndef DECISION_DEVICE_ID
#define DECISION_DEVICE_ID 0x4000
#endif

int dwatchdog_Base_Addr;

/* EXPORT_NO_SYMBOLS; */

/*---------------------------------------------------------------------*/
int dwatchdog_open(struct inode *inoder,struct file *flip)
{
#if 0
int type= TYPE(inoder->i_rdev);
 int num=NUM(inoder->i_rdev);
 MOD_INC_USE_COUNT;
#endif

 return 0;
}
/*---------------------------------------------------------------------*/
static int dwatchdog_release(struct inode *inoder,struct file *flip)
{
#if 0
  MOD_DEC_USE_COUNT;
#endif

  return 0;
}

/*---------------------------------------------------------------------*/
static ssize_t dwatchdog_read(struct file *flip,char *buf,size_t count,loff_t *ptr)
{
 int countt=0;
  if(ptr!=&flip->f_pos)  /* can't seek on this device */
  return -ESPIPE;
switch(MINOR(flip->f_dentry->d_inode->i_rdev))
 {
   case dwatchdog_MINOR: 	 
           buf[0]=readb(dwatchdog_Base_Addr+4);
           buf[1]=readb(dwatchdog_Base_Addr+5);
           buf[2]=readb(dwatchdog_Base_Addr+6);
           countt=3;
           break;
   default:
           return -EINVAL;        
 }          
 return countt;
}
/*---------------------------------------------------------------------*/
static ssize_t dwatchdog_write(struct file *flip,const char *buf,size_t count,loff_t *ptr)
{
 if(ptr!=&flip->f_pos)  /* can't seek on this device */
  return -ESPIPE;
 
 return 0;       /* do nothing */
}
/*---------------------------------------------------------------------*/
int dwatchdog_Myread(char *buf,int count)
{
 int countt;
 switch(buf[0])
  {
   case 0:
           buf[1]=inb(dwatchdog_Base_Addr);
           countt=2;
           break;
   case 1:
           buf[1]=inb(dwatchdog_Base_Addr+1);
           countt=2;
           break;
   case 2:
           buf[1]=inb(dwatchdog_Base_Addr+4);
           buf[2]=inb(dwatchdog_Base_Addr+5);
           buf[3]=inb(dwatchdog_Base_Addr+6);
           countt=4;
           break;
   case 3:
   case 4:
   case 5:
           buf[1]=inb(dwatchdog_Base_Addr+7);
           countt=2;
           break;
   default:
           countt=0;
           break;
  }
 return countt;

	
}
/*---------------------------------------------------------------------*/
void dwatchdog_Mywrite(char *buf,int count)
{
 char ch;
 switch(buf[0])
  {
   case 0:
           outb(0,dwatchdog_Base_Addr);
           break;
   case 1:
           outb(0,dwatchdog_Base_Addr+1);
           break;
   case 2:
           outb(buf[1],dwatchdog_Base_Addr+4);
           outb(buf[2],dwatchdog_Base_Addr+5);
           outb(buf[3],dwatchdog_Base_Addr+6);
           break;
   case 3:
           ch=buf[1];
           ch=(char)(ch|buf[2]);
           outb(ch,dwatchdog_Base_Addr+7);
           break;
   case 4:
           ch=buf[1];
           ch=buf[2]==0 ? ch|0x10 : ch&0xef;
           outb(ch,dwatchdog_Base_Addr+7);
           break;
   case 5:
           ch=buf[1];
           ch=ch|0x20;
           outb(ch,dwatchdog_Base_Addr+7);
           break;
   default:
           
           break;

  }
}
/*---------------------------------------------------------------------*/
int dwatchdog_ioctl(
    struct inode *inode,
    struct file *file,
    unsigned int ioctl_num,/* The number of the ioctl */
    unsigned long ioctl_param) /* The parameter to it */
{
  char param[4],param1[4];
  unsigned long int ch1=0;
  char *temp=(char *)ioctl_param;
  int i;
  char ch=0;
  switch (ioctl_num) 
   {
    case DECISION_ENABLE_COUNTER:
      param[0]=0;
      dwatchdog_Mywrite(param ,1);
      break;

    case DECISION_DISABLE_COUNTER:
      param[0]=1;
      dwatchdog_Mywrite(param , 1);
      break;

    case DECISION_GET_COUNTER:
      param[0]=2;
      dwatchdog_Myread(param,4);
      param1[0]=param[1];
      param1[1]=param[2];
      param1[2]=(char)(param[3]&0x0f);
      param1[3]=0;
      for(i=0;i<sizeof(unsigned long int);i++,temp++)
       put_user(param1[i],temp);      
      break; 
      
    case DECISION_SET_COUNTER:
      ch1=(unsigned long int)ioctl_param;
      param[0]=2;
      param[1]=(char) ch1 & 0xff;
      param[2]=(char)( (ch1 & 0x00ff00)>>8) ;
      param[3]=(char)( (ch1 & 0xff0000)>>16);
      dwatchdog_Mywrite(param , 4);
      break;
      
    case DECISION_SET_COUNTER_SOURCE:
      i=(int)temp;
      if(i>255)
       {
       get_user(ch,temp);
        }
        else
        ch=(char)i;
      param[0]=3;      
      dwatchdog_Myread(param,2);
      param[2]= (char)(ch&0x0f);
      dwatchdog_Mywrite(param , 3);
      break;

    case DECISION_SET_REMOTEPOWER_ON:
      param[0]=4;
      i=(int)temp;
      dwatchdog_Myread(param , 2);
      if(i>255)
       {
       get_user(ch,temp);
       }
      else
       ch=(char)i; 
      param[2]= ch !=0 ? 1 : 0;
      dwatchdog_Mywrite(param , 3);
      break;

    case DECISION_ENABLE_PCI_RESET:
      param[0]=5;
      dwatchdog_Myread(param , 2);
      dwatchdog_Mywrite(param , 2);
      break;

  }

  return 0;
}
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
static struct file_operations dwatchdog_fops={
read: dwatchdog_read,
write: dwatchdog_write,
ioctl: dwatchdog_ioctl ,
open: dwatchdog_open,
release: dwatchdog_release,
};
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
MODULE_AUTHOR("Delta");
MODULE_DESCRIPTION("Decision WATCH DOG Driver");
MODULE_LICENSE("GPL");
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/

static int __init dpciwatchdog_init(void)
{
 int index=0;
 struct pci_dev *dev = NULL;
 static int dev_count=0;
 dev_count++;
 if(dev_count>1)
  {
   printk(KERN_ERR"This drive only can open one time.\n");
   return -ENODEV;
  }

 while (index < 1 && dev == NULL && 
        (dev = pci_find_device(DECISION_VENDER_ID, DECISION_DEVICE_ID,dev))) 
 {
  index++;
 }
  if(dev==NULL)
  return -ENODEV;
  dwatchdog_Base_Addr=pci_resource_start(dev,3) & PCI_BASE_ADDRESS_IO_MASK;   
 printk("Decision Watch Dog:I got a base %x\n",dwatchdog_Base_Addr); 
 if(check_region(dwatchdog_Base_Addr,8)>=0)
  request_region(dwatchdog_Base_Addr,8,DEVICE_NAME);
 index=register_chrdev(dwatchdog_major,DEVICE_NAME,&dwatchdog_fops);
 if(index<0)
  {
  release_region(dwatchdog_Base_Addr,8);
  return index;
  }
 printk("Decision Watch Dog:Register Successful\n");  
 return 0;

}
/*---------------------------------------------------------------------*/
static void __exit dpciwatchdog_exit(void)
{
  release_region(dwatchdog_Base_Addr,8); 
  unregister_chrdev(dwatchdog_major,DEVICE_NAME);
 printk("Decision WatchDog :Unregister Successful!!\n");  
}
/*---------------------------------------------------------------------*/
module_init(dpciwatchdog_init);
module_exit(dpciwatchdog_exit);
